/* c4coml.h  (c)Copyright Sequiter Software Inc., 1988-1996. All rights reserved.*/
#ifndef S4OFF_COMMUNICATIONS
#ifdef S4LOCAL

typedef CONNECTION4ID S4FUNCTION S4LOCAL_FUNCTION_ID( void S4PTR * ) ;
typedef int S4FUNCTION S4LOCAL_FUNCTION_INT( void S4PTR * ) ;
typedef int S4FUNCTION S4LOCAL_FUNCTION_INT_THREE( void S4PTR *, void S4PTR * ) ;
typedef int S4FUNCTION S4LOCAL_FUNCTION_INT2( void S4PTR *, const void S4PTR * ) ;
typedef int S4FUNCTION S4LOCAL_FUNCTION_INT3X( void S4PTR *, const void S4PTR *, void S4PTR * ) ;
typedef void S4PTR *S4FUNCTION S4LOCAL_FUNCTION_PTR( void S4PTR * ) ;
typedef int S4FUNCTION S4LOCAL_FUNCTION_INT3( void S4PTR *, const void S4PTR *, const void S4PTR * ) ;
typedef void S4FUNCTION S4LOCAL_FUNCTION_CVOID( const void S4PTR * ) ;
typedef int S4FUNCTION S4LOCAL_FUNCTION_INT4( void S4PTR *, void S4PTR *, const void S4PTR *, const void S4PTR * ) ;

typedef struct CONNECTION4NETSt
{

   LINK4 link ;

   CODE4 *c4 ;
   HINSTANCE hInst ;

   /* function pointers */
   S4LOCAL_FUNCTION_PTR *alloc ;
   S4LOCAL_FUNCTION_INT *disconnect ;
   S4LOCAL_FUNCTION_INT *free ;
   S4LOCAL_FUNCTION_ID *id ;
   S4LOCAL_FUNCTION_ID *destId ;
   S4LOCAL_FUNCTION_INT_THREE *init ;
   S4LOCAL_FUNCTION_INT *initUndo ;
   S4LOCAL_FUNCTION_INT *messageLen ;
   S4LOCAL_FUNCTION_INT2 *send ;
   #ifdef S4SERVER
      S4LOCAL_FUNCTION_INT *disconnected ;
      S4LOCAL_FUNCTION_PTR *userId ;
   #endif

   void *connection4net ;     /* pointer to CONNECTION4NET in one of the
                                 transport protocol DLLs */

} CONNECTION4NET ;

typedef struct SOCKET4NETSt
{
   LINK4 link ;

   CODE4 *c4 ;
   HINSTANCE hInst ;
   int initUndone ;

   S4LOCAL_FUNCTION_PTR *alloc ;
   S4LOCAL_FUNCTION_INT *free ;
   S4LOCAL_FUNCTION_INT *initUndo ;
   S4LOCAL_FUNCTION_PTR *receive ;
   S4LOCAL_FUNCTION_CVOID *yield ;
   #ifdef S4SERVER
      S4LOCAL_FUNCTION_INT *connected ;
      S4LOCAL_FUNCTION_INT3X *connectClient ;
      S4LOCAL_FUNCTION_INT3 *initServer ;
      S4LOCAL_FUNCTION_INT *shutdownAdvertising ;
   #else
      S4LOCAL_FUNCTION_INT4 *connectServer ;
   #endif

   void *socket4net ;

}  SOCKET4NET  ;

void S4FUNCTION c4getFuncPtr( HINSTANCE, char S4PTR *, void S4PTR * S4PTR * ) ;

#endif  /* S4LOCAL */
#endif  /* S4OFF_COMMUNICATIONS */
